=== removed directory 'plugin/logging_syslog'
=== removed file 'plugin/logging_syslog/logging_syslog.cc'
--- plugin/logging_syslog/logging_syslog.cc	2010-05-18 18:20:56 +0000
+++ plugin/logging_syslog/logging_syslog.cc	1970-01-01 00:00:00 +0000
@@ -1,284 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2009 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-#include <drizzled/plugin/logging.h>
-#include <drizzled/gettext.h>
-#include <drizzled/session.h>
-
-#ifdef __sun
-# include <syslog.h>
-# include <plugin/logging_syslog/names.h>
-#else
-# define SYSLOG_NAMES 1
-# include <syslog.h>
-#endif
-
-#include <stdarg.h>
-#include <limits.h>
-#include <sys/time.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <fcntl.h>
-
-
-using namespace drizzled;
-
-static bool sysvar_logging_syslog_enable= false;
-static char* sysvar_logging_syslog_ident= NULL;
-static char* sysvar_logging_syslog_facility= NULL;
-static char* sysvar_logging_syslog_priority= NULL;
-static ulong sysvar_logging_syslog_threshold_slow= 0;
-static ulong sysvar_logging_syslog_threshold_big_resultset= 0;
-static ulong sysvar_logging_syslog_threshold_big_examined= 0;
-
-/* stolen from mysys/my_getsystime
-   until the Session has a good utime "now" we can use
-   will have to use this instead */
-
-static uint64_t get_microtime()
-{
-#if defined(HAVE_GETHRTIME)
-  return gethrtime()/1000;
-#else
-  uint64_t newtime;
-  struct timeval t;
-  /* loop is because gettimeofday may fail on some systems */
-  while (gettimeofday(&t, NULL) != 0) {}
-  newtime= (uint64_t)t.tv_sec * 1000000 + t.tv_usec;
-  return newtime;
-#endif
-}
-
-class Logging_syslog: public drizzled::plugin::Logging
-{
-
-  int syslog_facility;
-  int syslog_priority;
-
-public:
-
-  Logging_syslog()
-    : drizzled::plugin::Logging("Logging_syslog"),
-      syslog_facility(-1), syslog_priority(-1)
-  {
-
-    for (int ndx= 0; facilitynames[ndx].c_name; ndx++)
-    {
-      if (strcasecmp(facilitynames[ndx].c_name, sysvar_logging_syslog_facility) == 0)
-      {
-        syslog_facility= facilitynames[ndx].c_val;
-        break;
-      }
-    }
-    if (syslog_facility == -1)
-    {
-      errmsg_printf(ERRMSG_LVL_WARN,
-                    _("syslog facility \"%s\" not known, using \"local0\""),
-                    sysvar_logging_syslog_facility);
-      syslog_facility= LOG_LOCAL0;
-    }
-
-    for (int ndx= 0; prioritynames[ndx].c_name; ndx++)
-    {
-      if (strcasecmp(prioritynames[ndx].c_name, sysvar_logging_syslog_priority) == 0)
-      {
-        syslog_priority= prioritynames[ndx].c_val;
-        break;
-      }
-    }
-    if (syslog_priority == -1)
-    {
-      errmsg_printf(ERRMSG_LVL_WARN,
-                    _("syslog priority \"%s\" not known, using \"info\""),
-                    sysvar_logging_syslog_priority);
-      syslog_priority= LOG_INFO;
-    }
-
-    openlog(sysvar_logging_syslog_ident,
-            LOG_PID, syslog_facility);
-  }
-
-  ~Logging_syslog()
-  {
-    closelog();
-  }
-
-  virtual bool post (Session *session)
-  {
-    assert(session != NULL);
-  
-    // return if not enabled or query was too fast or resultset was too small
-    if (sysvar_logging_syslog_enable == false)
-      return false;
-    if (session->sent_row_count < sysvar_logging_syslog_threshold_big_resultset)
-      return false;
-    if (session->examined_row_count < sysvar_logging_syslog_threshold_big_examined)
-      return false;
-  
-    /* TODO, the session object should have a "utime command completed"
-       inside itself, so be more accurate, and so this doesnt have to
-       keep calling current_utime, which can be slow */
-  
-    uint64_t t_mark= get_microtime();
-  
-    if ((t_mark - session->start_utime) < sysvar_logging_syslog_threshold_slow)
-      return false;
-  
-    /* to avoid trying to printf %s something that is potentially NULL */
-  
-    const char *dbs= session->db.empty() ? "" : session->db.c_str();
-  
-    const char *qys= (! session->getQueryString().empty()) ? session->getQueryString().c_str() : "";
-    int qyl= 0;
-    if (qys)
-      qyl= session->getQueryLength();
-    
-    syslog(syslog_priority,
-           "thread_id=%ld query_id=%ld"
-           " db=\"%.*s\""
-           " query=\"%.*s\""
-           " command=\"%.*s\""
-           " t_connect=%lld t_start=%lld t_lock=%lld"
-           " rows_sent=%ld rows_examined=%ld"
-           " tmp_table=%ld total_warn_count=%ld\n",
-           (unsigned long) session->thread_id,
-           (unsigned long) session->getQueryId(),
-           (int)session->db.length(), dbs,
-           qyl, qys,
-           (int) command_name[session->command].length,
-           command_name[session->command].str,
-           (unsigned long long) (t_mark - session->getConnectMicroseconds()),
-           (unsigned long long) (t_mark - session->start_utime),
-           (unsigned long long) (t_mark - session->utime_after_lock),
-           (unsigned long) session->sent_row_count,
-           (unsigned long) session->examined_row_count,
-           (unsigned long) session->tmp_table,
-           (unsigned long) session->total_warn_count);
-  
-    return false;
-  }
-};
-
-static Logging_syslog *handler= NULL;
-
-static int logging_syslog_plugin_init(drizzled::module::Context &context)
-{
-  handler= new Logging_syslog();
-  context.add(handler);
-
-  return 0;
-}
-
-static DRIZZLE_SYSVAR_BOOL(
-  enable,
-  sysvar_logging_syslog_enable,
-  PLUGIN_VAR_NOCMDARG,
-  N_("Enable logging to syslog"),
-  NULL, /* check func */
-  NULL, /* update func */
-  false /* default */);
-
-static DRIZZLE_SYSVAR_STR(
-  ident,
-  sysvar_logging_syslog_ident,
-  PLUGIN_VAR_READONLY,
-  N_("Syslog Ident"),
-  NULL, /* check func */
-  NULL, /* update func*/
-  "drizzled" /* default */);
-
-static DRIZZLE_SYSVAR_STR(
-  facility,
-  sysvar_logging_syslog_facility,
-  PLUGIN_VAR_READONLY,
-  N_("Syslog Facility"),
-  NULL, /* check func */
-  NULL, /* update func*/
-  "local0" /* default */);  // local0 is what PostGreSQL uses by default
-
-static DRIZZLE_SYSVAR_STR(
-  priority,
-  sysvar_logging_syslog_priority,
-  PLUGIN_VAR_READONLY,
-  N_("Syslog Priority"),
-  NULL, /* check func */
-  NULL, /* update func*/
-  "info" /* default */);
-
-static DRIZZLE_SYSVAR_ULONG(
-  threshold_slow,
-  sysvar_logging_syslog_threshold_slow,
-  PLUGIN_VAR_OPCMDARG,
-  N_("Threshold for logging slow queries, in microseconds"),
-  NULL, /* check func */
-  NULL, /* update func */
-  0, /* default */
-  0, /* min */
-  ULONG_MAX, /* max */
-  0 /* blksiz */);
-
-static DRIZZLE_SYSVAR_ULONG(
-  threshold_big_resultset,
-  sysvar_logging_syslog_threshold_big_resultset,
-  PLUGIN_VAR_OPCMDARG,
-  N_("Threshold for logging big queries, for rows returned"),
-  NULL, /* check func */
-  NULL, /* update func */
-  0, /* default */
-  0, /* min */
-  ULONG_MAX, /* max */
-  0 /* blksiz */);
-
-static DRIZZLE_SYSVAR_ULONG(
-  threshold_big_examined,
-  sysvar_logging_syslog_threshold_big_examined,
-  PLUGIN_VAR_OPCMDARG,
-  N_("Threshold for logging big queries, for rows examined"),
-  NULL, /* check func */
-  NULL, /* update func */
-  0, /* default */
-  0, /* min */
-  ULONG_MAX, /* max */
-  0 /* blksiz */);
-
-static drizzle_sys_var* logging_syslog_system_variables[]= {
-  DRIZZLE_SYSVAR(enable),
-  DRIZZLE_SYSVAR(ident),
-  DRIZZLE_SYSVAR(facility),
-  DRIZZLE_SYSVAR(priority),
-  DRIZZLE_SYSVAR(threshold_slow),
-  DRIZZLE_SYSVAR(threshold_big_resultset),
-  DRIZZLE_SYSVAR(threshold_big_examined),
-  NULL
-};
-
-DRIZZLE_DECLARE_PLUGIN
-{
-  DRIZZLE_VERSION_ID,
-  "logging_syslog",
-  "0.2",
-  "Mark Atwood <mark@fallenpegasus.com>",
-  N_("Log to syslog"),
-  PLUGIN_LICENSE_GPL,
-  logging_syslog_plugin_init,
-  logging_syslog_system_variables,
-  NULL
-}
-DRIZZLE_DECLARE_PLUGIN_END;

=== removed file 'plugin/logging_syslog/names.h'
--- plugin/logging_syslog/names.h	2009-08-30 00:26:17 +0000
+++ plugin/logging_syslog/names.h	1970-01-01 00:00:00 +0000
@@ -1,100 +0,0 @@
-/*
- * Copyright (c) 1982, 1986, 1988, 1993
- *      The Regents of the University of California.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- *      @(#)syslog.h    8.1 (Berkeley) 6/2/93
- */
-#ifndef PLUGIN_LOGGING_SYSLOG_NAMES_H
-#define PLUGIN_LOGGING_SYSLOG_NAMES_H
-
-/* Solaris doesn't define these, so we copy them in. So Sad. */
-
-#ifndef LOG_FTP
-# define        LOG_FTP         (11<<3)
-#endif
-#ifndef LOG_AUTHPRIV
-# define        LOG_AUTHPRIV    (10<<3)
-#endif
-
-#define LOG_PRI(p)      ((p) & LOG_PRIMASK)
-#define LOG_MAKEPRI(fac, pri)   (((fac) << 3) | (pri))
-
-#define INTERNAL_NOPRI  0x10    /* the "no priority" priority */
-                                /* mark "facility" */
-#define INTERNAL_MARK   LOG_MAKEPRI(LOG_NFACILITIES, 0)
-typedef struct _code {
-        const char    *c_name;
-        int     c_val;
-} CODE;
-
-CODE prioritynames[] =
-  {
-    { "alert", LOG_ALERT },
-    { "crit", LOG_CRIT },
-    { "debug", LOG_DEBUG },
-    { "emerg", LOG_EMERG },
-    { "err", LOG_ERR },
-    { "error", LOG_ERR },               /* DEPRECATED */
-    { "info", LOG_INFO },
-    { "none", INTERNAL_NOPRI },         /* INTERNAL */
-    { "notice", LOG_NOTICE },
-    { "panic", LOG_EMERG },             /* DEPRECATED */
-    { "warn", LOG_WARNING },            /* DEPRECATED */
-    { "warning", LOG_WARNING },
-    { NULL, -1 }
-  };
-
-
-CODE facilitynames[] =
-  {
-    { "auth", LOG_AUTH },
-    { "authpriv", LOG_AUTHPRIV },
-    { "cron", LOG_CRON },
-    { "daemon", LOG_DAEMON },
-    { "ftp", LOG_FTP },
-    { "kern", LOG_KERN },
-    { "lpr", LOG_LPR },
-    { "mail", LOG_MAIL },
-    { "mark", INTERNAL_MARK },          /* INTERNAL */
-    { "news", LOG_NEWS },
-    { "security", LOG_AUTH },           /* DEPRECATED */
-    { "syslog", LOG_SYSLOG },
-    { "user", LOG_USER },
-    { "uucp", LOG_UUCP },
-    { "local0", LOG_LOCAL0 },
-    { "local1", LOG_LOCAL1 },
-    { "local2", LOG_LOCAL2 },
-    { "local3", LOG_LOCAL3 },
-    { "local4", LOG_LOCAL4 },
-    { "local5", LOG_LOCAL5 },
-    { "local6", LOG_LOCAL6 },
-    { "local7", LOG_LOCAL7 },
-    { NULL, -1 }
-  };
-
-
-#endif /* PLUGIN_LOGGING_SYSLOG_NAMES_H */

=== removed file 'plugin/logging_syslog/plugin.ini'
--- plugin/logging_syslog/plugin.ini	2009-11-29 19:55:08 +0000
+++ plugin/logging_syslog/plugin.ini	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-[plugin]
-title=Syslog Logging Plugin
-description=Logging Plugin that writes to syslog.
-headers=names.h

=== added directory 'plugin/syslog'
=== added file 'plugin/syslog/errmsg.cc'
--- plugin/syslog/errmsg.cc	1970-01-01 00:00:00 +0000
+++ plugin/syslog/errmsg.cc	2010-06-24 03:15:21 +0000
@@ -0,0 +1,66 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/gettext.h>
+#include <drizzled/session.h>
+
+#include <stdarg.h>
+
+#include "errmsg.h"
+#include "wrap.h"
+
+using namespace drizzled;
+
+ErrorMessage_syslog::ErrorMessage_syslog()
+  : drizzled::plugin::ErrorMessage("ErrorMessage_syslog")
+{
+  syslog_facility= WrapSyslog::getFacilityByName(syslog_module::sysvar_facility);
+  if (syslog_facility == -1)
+  {
+    errmsg_printf(ERRMSG_LVL_WARN,
+                  _("syslog facility \"%s\" not known, using \"local0\""),
+                  syslog_module::sysvar_facility);
+    syslog_facility= WrapSyslog::getFacilityByName("local0");
+    assert (! (syslog_facility == -1));
+  }
+
+  syslog_priority= WrapSyslog::getPriorityByName(syslog_module::sysvar_errmsg_priority);
+  if (syslog_priority == -1)
+  {
+    errmsg_printf(ERRMSG_LVL_WARN,
+                  _("syslog priority \"%s\" not known, using \"warn\""),
+                  syslog_module::sysvar_errmsg_priority);
+    syslog_priority= WrapSyslog::getPriorityByName("warn");
+    assert (! (syslog_priority == -1));
+  }
+
+  WrapSyslog::singleton().openlog(syslog_module::sysvar_ident);
+}
+
+bool ErrorMessage_syslog::errmsg(drizzled::Session *,
+                                 int,
+                                 const char *format, va_list ap)
+{
+  if (syslog_module::sysvar_errmsg_enable == false)
+    return false;
+  WrapSyslog::singleton().vlog(syslog_facility, syslog_priority, format, ap);
+  return false;
+}

=== added file 'plugin/syslog/errmsg.h'
--- plugin/syslog/errmsg.h	1970-01-01 00:00:00 +0000
+++ plugin/syslog/errmsg.h	2010-06-24 03:15:21 +0000
@@ -0,0 +1,42 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef PLUGIN_SYSLOG_ERRMSG_H
+#define PLUGIN_SYSLOG_ERRMSG_H
+
+#include "module.h"
+#include <stdarg.h>
+#include <drizzled/plugin/error_message.h>
+
+class ErrorMessage_syslog : public drizzled::plugin::ErrorMessage
+{
+ private:
+  int syslog_facility;
+  int syslog_priority;
+
+  ErrorMessage_syslog(const ErrorMessage_syslog&);
+  ErrorMessage_syslog& operator=(const ErrorMessage_syslog&);
+
+ public:
+  ErrorMessage_syslog();
+
+  virtual bool errmsg(drizzled::Session *, int, const char *format, va_list ap);
+};
+
+#endif /* PLUGIN_SYSLOG_ERRMSG_H */

=== added file 'plugin/syslog/function.cc'
--- plugin/syslog/function.cc	1970-01-01 00:00:00 +0000
+++ plugin/syslog/function.cc	2010-06-24 03:15:21 +0000
@@ -0,0 +1,76 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/gettext.h>
+#include <drizzled/session.h>
+
+#include "function.h"
+#include "wrap.h"
+
+using namespace drizzled;
+
+Function_syslog::Function_syslog()
+  : Item_str_func()
+{
+  WrapSyslog::singleton().openlog(syslog_module::sysvar_ident);
+}
+
+String *Function_syslog::val_str(String *s)
+{
+
+  if (args[0]->null_value || args[1]->null_value || args[2]->null_value)
+  {
+    null_value= 1;
+    return 0;
+  }
+
+  int syslog_facility= WrapSyslog::getFacilityByName(args[0]->val_str(s)->c_ptr());
+  int syslog_priority= WrapSyslog::getPriorityByName(args[1]->val_str(s)->c_ptr());
+
+  if ((syslog_facility == -1) || (syslog_priority == -1))
+  {
+    null_value= 1;
+    return 0;
+  }
+
+  char *syslog_string= args[2]->val_str(s)->c_ptr();
+  if ((syslog_string == 0) || (syslog_string[0] == 0))
+  {
+    null_value= 1;
+    return 0;
+  }
+
+  WrapSyslog::singleton().log(syslog_facility, syslog_priority, "%s", syslog_string);
+
+  null_value= 0;
+  return args[2]->val_str(s);
+}
+
+void Function_syslog::fix_length_and_dec()
+{
+  max_length= args[0]->max_length;
+}
+
+bool Function_syslog::check_argument_count(int n)
+{
+  return (n == 3);
+}
+

=== added file 'plugin/syslog/function.h'
--- plugin/syslog/function.h	1970-01-01 00:00:00 +0000
+++ plugin/syslog/function.h	2010-06-24 03:15:21 +0000
@@ -0,0 +1,45 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef PLUGIN_SYSLOG_FUNCTION_H
+#define PLUGIN_SYSLOG_FUNCTION_H
+
+#include "module.h"
+
+#include <drizzled/plugin/function.h>
+#include <drizzled/item/func.h>
+#include <drizzled/function/str/strfunc.h>
+
+class Function_syslog : public drizzled::Item_str_func
+{
+private:
+  Function_syslog(const Function_syslog&);
+  Function_syslog& operator=(const Function_syslog&);
+
+public:
+  Function_syslog();
+
+  const char *func_name() const { return "syslog"; }
+
+  drizzled::String *val_str(drizzled::String *s);
+  void fix_length_and_dec();
+  bool check_argument_count(int n);
+};
+
+#endif /* PLUGIN_SYSLOG_FUNCTION_H */

=== added file 'plugin/syslog/logging.cc'
--- plugin/syslog/logging.cc	1970-01-01 00:00:00 +0000
+++ plugin/syslog/logging.cc	2010-06-24 03:15:21 +0000
@@ -0,0 +1,137 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/gettext.h>
+#include <drizzled/session.h>
+
+#include <stdarg.h>
+#include <limits.h>
+#include <sys/time.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#include "logging.h"
+#include "wrap.h"
+
+using namespace drizzled;
+
+/* stolen from mysys/my_getsystime
+   until the Session has a good utime "now" we can use
+   will have to use this instead */
+
+static uint64_t get_microtime()
+{
+#if defined(HAVE_GETHRTIME)
+  return gethrtime()/1000;
+#else
+  uint64_t newtime;
+  struct timeval t;
+  /* loop is because gettimeofday may fail on some systems */
+  while (gettimeofday(&t, NULL) != 0) {}
+  newtime= (uint64_t)t.tv_sec * 1000000 + t.tv_usec;
+  return newtime;
+#endif
+}
+
+Logging_syslog::Logging_syslog()
+  : drizzled::plugin::Logging("Logging_syslog")
+{
+  syslog_facility= WrapSyslog::getFacilityByName(syslog_module::sysvar_facility);
+  if (syslog_facility < 0)
+  {
+    errmsg_printf(ERRMSG_LVL_WARN,
+                  _("syslog facility \"%s\" not known, using \"local0\""),
+                  syslog_module::sysvar_facility);
+    syslog_facility= WrapSyslog::getFacilityByName("local0");
+  }
+
+  syslog_priority= WrapSyslog::getPriorityByName(syslog_module::sysvar_logging_priority);
+  if (syslog_priority < 0)
+  {
+    errmsg_printf(ERRMSG_LVL_WARN,
+                  _("syslog priority \"%s\" not known, using \"info\""),
+                  syslog_module::sysvar_logging_priority);
+    syslog_priority= WrapSyslog::getPriorityByName("info");
+  }
+
+  WrapSyslog::singleton().openlog(syslog_module::sysvar_ident);
+}
+
+
+bool Logging_syslog::post (Session *session)
+{
+  assert(session != NULL);
+
+  if (syslog_module::sysvar_logging_enable == false)
+    return false;
+  
+  // return if query was not too small
+  if (session->sent_row_count < syslog_module::sysvar_logging_threshold_big_resultset)
+    return false;
+  if (session->examined_row_count < syslog_module::sysvar_logging_threshold_big_examined)
+    return false;
+  
+  /* TODO, the session object should have a "utime command completed"
+     inside itself, so be more accurate, and so this doesnt have to
+     keep calling current_utime, which can be slow */
+  
+  uint64_t t_mark= get_microtime();
+
+  // return if query was not too slow
+  if ((t_mark - session->start_utime) < syslog_module::sysvar_logging_threshold_slow)
+    return false;
+  
+  /* to avoid trying to printf %s something that is potentially NULL */
+  
+  const char *dbs= session->db.empty() ? "" : session->db.c_str();
+  
+  const char *qys= (! session->getQueryString().empty()) ? session->getQueryString().c_str() : "";
+  int qyl= 0;
+  if (qys)
+    qyl= session->getQueryLength();
+
+  WrapSyslog::singleton()
+    .log(syslog_facility, syslog_priority,
+         "thread_id=%ld query_id=%ld"
+         " db=\"%.*s\""
+         " query=\"%.*s\""
+         " command=\"%.*s\""
+         " t_connect=%lld t_start=%lld t_lock=%lld"
+         " rows_sent=%ld rows_examined=%ld"
+         " tmp_table=%ld total_warn_count=%ld\n",
+         (unsigned long) session->thread_id,
+         (unsigned long) session->getQueryId(),
+         (int) session->db.length(), dbs,
+         qyl, qys,
+         (int) command_name[session->command].length,
+         command_name[session->command].str,
+         (unsigned long long) (t_mark - session->getConnectMicroseconds()),
+         (unsigned long long) (t_mark - session->start_utime),
+         (unsigned long long) (t_mark - session->utime_after_lock),
+         (unsigned long) session->sent_row_count,
+         (unsigned long) session->examined_row_count,
+         (unsigned long) session->tmp_table,
+         (unsigned long) session->total_warn_count);
+  
+    return false;
+}

=== added file 'plugin/syslog/logging.h'
--- plugin/syslog/logging.h	1970-01-01 00:00:00 +0000
+++ plugin/syslog/logging.h	2010-06-24 03:15:21 +0000
@@ -0,0 +1,42 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef PLUGIN_SYSLOG_LOGGING_H
+#define PLUGIN_SYSLOG_LOGGING_H
+
+#include "module.h"
+#include <drizzled/plugin/logging.h>
+
+class Logging_syslog: public drizzled::plugin::Logging
+{
+ private:
+  int syslog_facility;
+  int syslog_priority;
+
+  Logging_syslog(const Logging_syslog&);
+  Logging_syslog& operator=(const Logging_syslog&);
+
+ public:
+  Logging_syslog();
+
+  virtual bool post (drizzled::Session *session);
+};
+
+#endif /* PLUGIN_SYSLOG_LOGGING_H */

=== added file 'plugin/syslog/module.cc'
--- plugin/syslog/module.cc	1970-01-01 00:00:00 +0000
+++ plugin/syslog/module.cc	2010-06-24 03:15:21 +0000
@@ -0,0 +1,160 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+#include "module.h"
+
+#include <drizzled/plugin.h>
+#include <drizzled/plugin/logging.h>
+#include <drizzled/plugin/error_message.h>
+#include <drizzled/plugin/function.h>
+
+#include "logging.h"
+#include "errmsg.h"
+#include "function.h"
+
+using namespace drizzled;
+
+namespace syslog_module
+{
+
+char* sysvar_ident;
+char* sysvar_facility;
+bool sysvar_logging_enable;
+char* sysvar_logging_priority;
+unsigned long sysvar_logging_threshold_slow;
+unsigned long sysvar_logging_threshold_big_resultset;
+unsigned long sysvar_logging_threshold_big_examined;
+bool sysvar_errmsg_enable;
+char* sysvar_errmsg_priority;
+
+static int init(drizzled::module::Context &context)
+{
+  context.add(new Logging_syslog());
+  context.add(new ErrorMessage_syslog());
+  context.add(new plugin::Create_function<Function_syslog>("syslog"));
+  return 0;
+}
+
+static DRIZZLE_SYSVAR_STR(
+  ident,
+  sysvar_ident,
+  PLUGIN_VAR_READONLY,
+  N_("Syslog Ident"),
+  NULL, /* check func */
+  NULL, /* update func*/
+  "drizzled" /* default */);
+
+static DRIZZLE_SYSVAR_STR(
+  facility,
+  sysvar_facility,
+  PLUGIN_VAR_READONLY,
+  N_("Syslog Facility"),
+  NULL, /* check func */
+  NULL, /* update func*/
+  "local0" /* default */);  // local0 is what PostGreSQL uses by default
+
+static DRIZZLE_SYSVAR_BOOL(
+  logging_enable,
+  sysvar_logging_enable,
+  PLUGIN_VAR_NOCMDARG,
+  N_("Enable logging to syslog of the query log"),
+  NULL, /* check func */
+  NULL, /* update func */
+  false /* default */);
+
+static DRIZZLE_SYSVAR_STR(
+  logging_priority,
+  sysvar_logging_priority,
+  PLUGIN_VAR_READONLY,
+  N_("Syslog Priority of query logging"),
+  NULL, /* check func */
+  NULL, /* update func*/
+  "info" /* default */);
+
+static DRIZZLE_SYSVAR_ULONG(
+  logging_threshold_slow,
+  sysvar_logging_threshold_slow,
+  PLUGIN_VAR_OPCMDARG,
+  N_("Threshold for logging slow queries, in microseconds"),
+  NULL, /* check func */
+  NULL, /* update func */
+  0, /* default */
+  0, /* min */
+  ULONG_MAX, /* max */
+  0 /* blksiz */);
+
+static DRIZZLE_SYSVAR_ULONG(
+  logging_threshold_big_resultset,
+  sysvar_logging_threshold_big_resultset,
+  PLUGIN_VAR_OPCMDARG,
+  N_("Threshold for logging big queries, for rows returned"),
+  NULL, /* check func */
+  NULL, /* update func */
+  0, /* default */
+  0, /* min */
+  ULONG_MAX, /* max */
+  0 /* blksiz */);
+
+static DRIZZLE_SYSVAR_ULONG(
+  logging_threshold_big_examined,
+  sysvar_logging_threshold_big_examined,
+  PLUGIN_VAR_OPCMDARG,
+  N_("Threshold for logging big queries, for rows examined"),
+  NULL, /* check func */
+  NULL, /* update func */
+  0, /* default */
+  0, /* min */
+  ULONG_MAX, /* max */
+  0 /* blksiz */);
+
+static DRIZZLE_SYSVAR_BOOL(
+  errmsg_enable,
+  sysvar_errmsg_enable,
+  PLUGIN_VAR_NOCMDARG,
+  N_("Enable logging to syslog of the error messages"),
+  NULL, /* check func */
+  NULL, /* update func */
+  false /* default */);
+
+static DRIZZLE_SYSVAR_STR(
+  errmsg_priority,
+  sysvar_errmsg_priority,
+  PLUGIN_VAR_READONLY,
+  N_("Syslog Priority of error messages"),
+  NULL, /* check func */
+  NULL, /* update func*/
+  "warning" /* default */);
+
+static drizzle_sys_var* system_variables[]= {
+  DRIZZLE_SYSVAR(ident),
+  DRIZZLE_SYSVAR(facility),
+  DRIZZLE_SYSVAR(logging_enable),
+  DRIZZLE_SYSVAR(logging_priority),
+  DRIZZLE_SYSVAR(logging_threshold_slow),
+  DRIZZLE_SYSVAR(logging_threshold_big_resultset),
+  DRIZZLE_SYSVAR(logging_threshold_big_examined),
+  DRIZZLE_SYSVAR(errmsg_enable),
+  DRIZZLE_SYSVAR(errmsg_priority),
+  NULL
+};
+
+} // namespace syslog_module
+
+DRIZZLE_PLUGIN(syslog_module::init, syslog_module::system_variables);

=== added file 'plugin/syslog/module.h'
--- plugin/syslog/module.h	1970-01-01 00:00:00 +0000
+++ plugin/syslog/module.h	2010-06-24 03:15:21 +0000
@@ -0,0 +1,38 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef PLUGIN_SYSLOG_MODULE_H
+#define PLUGIN_SYSLOG_MODULE_H
+
+namespace syslog_module
+{
+
+extern char* sysvar_ident;
+extern char* sysvar_facility;
+extern bool sysvar_logging_enable;
+extern char* sysvar_logging_priority;
+extern unsigned long sysvar_logging_threshold_slow;
+extern unsigned long sysvar_logging_threshold_big_resultset;
+extern unsigned long sysvar_logging_threshold_big_examined;
+extern bool sysvar_errmsg_enable;
+extern char* sysvar_errmsg_priority;
+
+} // namespace syslog_module
+
+#endif /* PLUGIN_SYSLOG_MODULE_H */

=== added file 'plugin/syslog/names.h'
--- plugin/syslog/names.h	1970-01-01 00:00:00 +0000
+++ plugin/syslog/names.h	2010-06-24 03:15:21 +0000
@@ -0,0 +1,100 @@
+/*
+ * Copyright (c) 1982, 1986, 1988, 1993
+ *      The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *      @(#)syslog.h    8.1 (Berkeley) 6/2/93
+ */
+#ifndef PLUGIN_SYSLOG_NAMES_H
+#define PLUGIN_SYSLOG_NAMES_H
+
+/* Solaris doesn't define these, so we copy them in. So Sad. */
+
+#ifndef LOG_FTP
+# define        LOG_FTP         (11<<3)
+#endif
+#ifndef LOG_AUTHPRIV
+# define        LOG_AUTHPRIV    (10<<3)
+#endif
+
+#define LOG_PRI(p)      ((p) & LOG_PRIMASK)
+#define LOG_MAKEPRI(fac, pri)   (((fac) << 3) | (pri))
+
+#define INTERNAL_NOPRI  0x10    /* the "no priority" priority */
+                                /* mark "facility" */
+#define INTERNAL_MARK   LOG_MAKEPRI(LOG_NFACILITIES, 0)
+typedef struct _code {
+        const char    *c_name;
+        int     c_val;
+} CODE;
+
+CODE prioritynames[] =
+  {
+    { "alert", LOG_ALERT },
+    { "crit", LOG_CRIT },
+    { "debug", LOG_DEBUG },
+    { "emerg", LOG_EMERG },
+    { "err", LOG_ERR },
+    { "error", LOG_ERR },               /* DEPRECATED */
+    { "info", LOG_INFO },
+    { "none", INTERNAL_NOPRI },         /* INTERNAL */
+    { "notice", LOG_NOTICE },
+    { "panic", LOG_EMERG },             /* DEPRECATED */
+    { "warn", LOG_WARNING },            /* DEPRECATED */
+    { "warning", LOG_WARNING },
+    { NULL, -1 }
+  };
+
+
+CODE facilitynames[] =
+  {
+    { "auth", LOG_AUTH },
+    { "authpriv", LOG_AUTHPRIV },
+    { "cron", LOG_CRON },
+    { "daemon", LOG_DAEMON },
+    { "ftp", LOG_FTP },
+    { "kern", LOG_KERN },
+    { "lpr", LOG_LPR },
+    { "mail", LOG_MAIL },
+    { "mark", INTERNAL_MARK },          /* INTERNAL */
+    { "news", LOG_NEWS },
+    { "security", LOG_AUTH },           /* DEPRECATED */
+    { "syslog", LOG_SYSLOG },
+    { "user", LOG_USER },
+    { "uucp", LOG_UUCP },
+    { "local0", LOG_LOCAL0 },
+    { "local1", LOG_LOCAL1 },
+    { "local2", LOG_LOCAL2 },
+    { "local3", LOG_LOCAL3 },
+    { "local4", LOG_LOCAL4 },
+    { "local5", LOG_LOCAL5 },
+    { "local6", LOG_LOCAL6 },
+    { "local7", LOG_LOCAL7 },
+    { NULL, -1 }
+  };
+
+
+#endif /* PLUGIN_SYSLOG_NAMES_H */

=== added file 'plugin/syslog/plugin.ini'
--- plugin/syslog/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/syslog/plugin.ini	2010-06-24 03:15:21 +0000
@@ -0,0 +1,20 @@
+[plugin]
+title=Syslog
+description=Syslog interface for query log, error messages, and functions
+version=0.3
+author=Mark Atwood <me@mark.atwood.name>
+license=PLUGIN_LICENSE_GPL
+load_by_default=yes
+headers=
+ module.h
+ logging.h
+ errmsg.h
+ function.h
+ wrap.h
+ names.h
+sources=
+ module.cc
+ logging.cc
+ errmsg.cc
+ function.cc
+ wrap.cc

=== added file 'plugin/syslog/wrap.cc'
--- plugin/syslog/wrap.cc	1970-01-01 00:00:00 +0000
+++ plugin/syslog/wrap.cc	2010-06-24 03:15:21 +0000
@@ -0,0 +1,105 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "wrap.h"
+
+#include <assert.h>
+#include <stdarg.h>
+#include <string.h>
+
+#ifdef __sun
+# include <syslog.h>
+# include "names.h"
+#else
+# define SYSLOG_NAMES 1
+# include <syslog.h>
+#endif
+
+WrapSyslog::WrapSyslog () :
+  openlog_check(false)
+{ }
+
+WrapSyslog::~WrapSyslog ()
+{
+  ::closelog();
+  delete &(WrapSyslog::singleton());
+}
+
+WrapSyslog& WrapSyslog::singleton()
+{
+  static WrapSyslog *handle = new WrapSyslog();
+  return *handle;
+}
+
+/* TODO, for the sake of performance, scan through all the priority
+   and facility names, and construct a stl hash, minimal perfect hash,
+   or some other high performance read data structure.  This can even
+   be done at compile time. */
+
+int WrapSyslog::getPriorityByName(const char *priority_name)
+{
+  for (int ndx= 0; prioritynames[ndx].c_name; ndx++)
+  {
+    if (strcasecmp(prioritynames[ndx].c_name, priority_name) == 0)
+    {
+      return prioritynames[ndx].c_val;
+    }
+  }
+  // no matching priority found
+  return -1;
+}
+
+int WrapSyslog::getFacilityByName(const char *facility_name)
+{
+  for (int ndx= 0; facilitynames[ndx].c_name; ndx++)
+  {
+    if (strcasecmp(facilitynames[ndx].c_name, facility_name) == 0)
+    {
+      return facilitynames[ndx].c_val;
+    }
+  }
+  // no matching facility found
+  return -1;
+}
+
+void WrapSyslog::openlog(char *ident)
+{
+  if (openlog_check == false)
+  {
+    memset(openlog_ident, 0, sizeof(openlog_ident));
+    strncpy(openlog_ident, ident, sizeof(openlog_ident)-1);
+    ::openlog(openlog_ident, LOG_PID, LOG_USER);
+    openlog_check= true;
+  }
+}
+
+void WrapSyslog::vlog(int facility, int priority, const char *format, va_list ap)
+{
+  assert(openlog_check == true);
+  vsyslog(facility | priority, format, ap);
+}
+
+void WrapSyslog::log (int facility, int priority, const char *format, ...)
+{
+  assert(openlog_check == true);
+  va_list ap;
+  va_start(ap, format);
+  vsyslog(facility | priority, format, ap);
+  va_end(ap);
+}

=== added file 'plugin/syslog/wrap.h'
--- plugin/syslog/wrap.h	1970-01-01 00:00:00 +0000
+++ plugin/syslog/wrap.h	2010-06-24 03:15:21 +0000
@@ -0,0 +1,48 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Mark Atwood
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef PLUGIN_SYSLOG_WRAP_H
+#define PLUGIN_SYSLOG_WRAP_H
+
+#include <stdarg.h>
+
+class WrapSyslog
+{
+ private:
+  WrapSyslog(const WrapSyslog&);
+  WrapSyslog& operator=(const WrapSyslog&);
+
+  WrapSyslog();
+
+  bool openlog_check;
+  char openlog_ident[32];
+
+ public:
+  ~WrapSyslog();
+  static WrapSyslog& singleton();
+
+  static int getFacilityByName(const char *);
+  static int getPriorityByName(const char *);
+
+  void openlog(char *ident);
+  void vlog(int facility, int priority, const char *format, va_list ap);
+  void log(int facility, int priority, const char *format, ...);
+};
+
+#endif /* PLUGIN_SYSLOG_WRAP_H */

=== modified file 'support-files/drizzle.spec.in'
--- support-files/drizzle.spec.in	2010-05-14 20:38:31 +0000
+++ support-files/drizzle.spec.in	2010-06-24 03:15:21 +0000
@@ -522,8 +522,6 @@
 %{_libdir}/drizzle/liblength_plugin.so
 %{_libdir}/drizzle/liblogging_query_plugin.la
 %{_libdir}/drizzle/liblogging_query_plugin.so
-%{_libdir}/drizzle/liblogging_syslog_plugin.la
-%{_libdir}/drizzle/liblogging_syslog_plugin.so
 %{_libdir}/drizzle/libmd5_plugin.la
 %{_libdir}/drizzle/libmd5_plugin.so
 %{_libdir}/drizzle/libmemcached_functions_plugin.la
@@ -542,6 +540,8 @@
 %{_libdir}/drizzle/libsingle_thread_plugin.so
 %{_libdir}/drizzle/libsleep_plugin.la
 %{_libdir}/drizzle/libsleep_plugin.so
+%{_libdir}/drizzle/libsyslog_plugin.la
+%{_libdir}/drizzle/libsyslog_plugin.so
 %{_libdir}/drizzle/libtableprototester_plugin.la
 %{_libdir}/drizzle/libtableprototester_plugin.so
 %{_libdir}/drizzle/libtransaction_log_plugin.la

